
public class ActiveObjectnThreadsDemo {

	public static class Timer implements Runnable {
		Thread thread = new Thread(this);
		
		final String name;
		final int interval;
		int timeLeft;
		
		public Timer(String name, int intervalSeconds, int startTimeSeconds) {
			this.name = name;
			interval = intervalSeconds;
			timeLeft = startTimeSeconds;
		}

		@Override
		public void run() {
			while (timeLeft > 0) {
				System.out.println(name + " " + timeLeft);
				try {
					Thread.sleep(interval * 1000);
				} catch (InterruptedException e) {
					break;
				}
				timeLeft -= interval;
			}
			System.out.println(name + " is done");
		}
	}
	
	public static void main(String[] args) {
		Timer t1 = new Timer("A", 2, 10);
		Timer t2 = new Timer("B", 3, 12);
		t1.thread.start();
		t2.thread.start();
		t2.thread.setPriority(Thread.MIN_PRIORITY);
		try {
			t1.thread.join();
			t2.thread.join();
		} catch (InterruptedException e) {
			
		}
		System.out.println("both are done");
	}

}
