import java.util.concurrent.*;

public class ForkJoin2 {

	public static class AktivTimer {
		//(Modernare) alternativ till att använda Thread direkt.
		//Nu kan flera metoder skicka tasks till poolen istället, även om exemplet
		//bara innehåller en metod.
		final ForkJoinPool fj = new ForkJoinPool();
		final String name;
		final int interval;
		int timeLeft;

		public AktivTimer(String name, int intervalSeconds, int startTimeSeconds) {
			this.name = name;
			interval = intervalSeconds;
			timeLeft = startTimeSeconds;
		}
		//ForkJoinTask är generisk. Eftersom vi här returnerar void kan vi
		// strunta i typvariabeln, alt. skriva ForkJoinTask<?>.
		public ForkJoinTask getName(){
			return fj.submit(() ->System.out.println ("getName: " + name));
		}
		public ForkJoinTask<?> startTimer() {
			return fj.submit (() -> {
				while (timeLeft > 0) {
						System.out.println(name + " " + timeLeft);
						try {
							Thread.sleep(interval * 1000);
						} catch (InterruptedException e) {
							break;
						}
						timeLeft -= interval;
					}
					System.out.println(name + " is done");
				});
			}
		}

	public static void main(String[] args) {
		AktivTimer t1 = new AktivTimer("A", 2, 10);
		AktivTimer t2 = new AktivTimer("B", 3, 12);
		ForkJoinTask taskA = t1.startTimer();
		ForkJoinTask taskB = t2.startTimer();
		ForkJoinTask taskA2 = t1.getName();
		taskA.join();
		taskB.join();

		System.out.println("both are done");
	}

}
